#include <tty.hpp>
#include <stdint.h>
#include <multiboot.h>

#define checkFlag(flags,bit)   ((flags) & (1 << (bit)))

extern "C" void kmain(multiboot_info_t *mbi,unsigned int magic);

void  kmain(multiboot_info_t *mbi,unsigned int magic)
{
	tty.clear();
	
	mbi = 0;
	
	if(magic != MULTIBOOT_BOOTLOADER_MAGIC)
	{
		tty << "This is not a multiboot-compliant loader.\n";
		tty << "Use a multiboot-compliant loader,\n";
		tty << "such as GRUB.\n";
		tty << "\nHalting system..\n";
		asm("cli");
		asm("hlt");
	}
	
	tty << "Caldera 0.0.3\n\n";
	tty << "-------------------------------------------------------------------------------\n";
	tty << "|This program is free software; you can                                       |\n";
	tty << "|distribute it under the terms of the                                         |\n";
	tty << "|GNU General Public License.                                                  |\n";
	tty << "|                                                                             |\n";
	tty << "|-----------------------------------------------------------------------------|\n";
	tty << "|                                                                             |\n";
	tty << "|THIS SOFTWARE IS PROVIDED \"AS IS\",WITHOUT WARRANTY OF ANY KIND,EXPRESS OR    |\n";
	tty << "|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |\n";
	tty << "|FITNESS FOR A PARTICULAR PURPOSE AND NONIFRINGEMENT. IN NO EVENT SHALL ANY   |\n";
	tty << "|DEVELOPER OR DISTRIBUTOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,|\n";
	tty << "|WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM OUT OF OR  |\n";
	tty << "|IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.|\n";
	tty << "|                                                                             |\n";
	tty << "|-----------------------------------------------------------------------------|\n\n\n";
	
	for(unsigned int i = 0; i < 100000000; i++);
	tty.clear();
	
	tty << "Halt! :D";
}