#include <stdint.h>

// We need memmove to be able to use *this

void *memmove(void *dest, const void *src, unsigned count)
{
	const char*sp = (const char *)src; // Temporary pointers
	char *dp = (char *)dest;
	
	for(; count != 0; count--) *dp++ = *sp++; // Copy it!
	
	src = 0; // Null out the source address
	
	return dest; // Return the address of dest for future usage
}

void memset(uint8 *dest,uint8 value, uint32 length)
{
	uint8 *temp = (uint8 *)dest;
	
	for(; length != 0; length--) *temp++ = value;
}

void itoa(char *buffer, int base , int d ) // Needed for things like printf, TTY, etc..
{
	char *p = buffer;
	char *p1, *p2;
	unsigned long ud = d;
	int divisor = 10;
	
	if(base == 'd' && d < 0 )
	{
		*p++ = '-';
		buffer++;
		ud = -d;
	}
	
	else if(base == 'x')
		divisor = 16;
	
	do
	{
		int remainder = ud % divisor;
		
		*p++ = (remainder < 10) ? remainder + '0' : remainder + 'a' - 10;
	}while(ud /= divisor);
	
	*p = 0;
	p1 = buffer;
	p2 = p -1;
	
	while(p1 < p2)
	{
		char tmp = *p1;
		*p1 = *p2;
		*p2 = tmp;
		p1++;
		p2--;
	}
}